#include <std.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>

#define TRUE   1
#define FALSE  0
#define DONT_CARE "[don't care]"
typedef unsigned char BYTE;
typedef BYTE *	pBYTE;


typedef struct
{
   int   nClist;
   int   minyear;
   int   maxyear;
   int   minx;
   int   maxx;
   int   miny;
   int   maxy;
   int   gameokay;
   int   minfreq;
   int   maxfreq;
   int   mincolors;
   int   maxcolors;
   char  szMan[256];
   char  szName[256];
   char  szStartName[256];
   int   vertical;
   int   vector;
   int   clone;
   char  szCloneName[256];
   int   neogeo;
   int   players;
   int   depth;
} CLIST;
typedef CLIST *pCLIST;


#define  MAX_CLIST_DEFS 128

#define  MAX_CFGS       64
typedef struct
{
   char     GameName[12];
   char     szDispName[64];
   char     szParent[12];
   char     szExtension[8];
   BYTE     Orientation;
   BYTE     SaveOrient;
   BYTE     nGameType;
	short int nConfigs[MAX_CFGS];
   BYTE     bLocalConfig;
   BYTE     bChanged;
   fpos_t   fFilePos;
   BYTE bRandomRun;
} MAMEGAME;
typedef MAMEGAME *pMAMEGAME;

typedef struct
{
   char  szFileName[256];
   char  szDescription[256];
   char  szCloneOf[256];
   char  szResolution[256];
   char  szControl[256];
   char  szYear[256];
   char  szMan[256];
	int	nColors;
	int	nFreq;
	int	nRotated;
	int	nOkay;
	int	nClone;
   int   nVector;
   int   nPlayers;
   int   nCoins;
	int	nColorDepth;
	int	nHiScoreOK;
	int	nColorOK;
} MAMEDESC;

typedef MAMEDESC * pMAMEDESC;

#define	NEOGEO			"neogeo"

#define  RMSFORMAT      "RMS32BIT5"
#define  RMS_HEAD_SIZE  10
#define  MAX_INFO_SIZE  128000

int checkfile(char *szfile);
int checkclistfiles(void);
int findident(char *buffer,char *ident);
int checkrms(void);
int getinfo(void);
int parseinfo(FILE *fCL);
char *tidyget(char *inbuff,int len,FILE *f);
void getstring(char *buffer,char *out);
int getyesno(char *buffer);
int getval(char *buffer);
char *dispno(int in);
char *trimspaces(char *in);
char *getequalval(char *buffer);
void createclists(void);
void getrange(char *buffer,int *pmin,int *pmax);
int getgameinfo(pMAMEGAME game,pMAMEDESC gameinfo);
char *getitem(char *out,char *in,int nindex,int bsize,char sep);
void setcustom(pMAMEGAME pGame,pMAMEDESC pGameInfo,pCLIST pClistDef,int *nogames);
void getres(char *szRes,int *pX,int *pY);
char *dispstr(char *szIn);
char *disprange(int in);
int helpwanted(int argc,char **argv);
